/*	dispn.c	associated subroutines for matching sequences */

#include <stdio.h>

#include "ffasta.h"
#include "ndispn.h"

#define XTERNAL
#include "upam.gbl"

#define YES 1
#define NO 0
extern FILE *outfd;
extern dnaseq;
extern long smark[4];
extern long n1;
extern long min0,min1,max0,max1;
extern long smin0, smin1, smins;
extern long loffset;
extern long sq0off, sq1off;
extern char name0[],name1[];
extern long llen, markx, showall;

#define MAXOUT 201

/*==========================================================
*/
void DisplayConsensusAlignment(char *inQuerySeq, char *inLibSeq, 
                               long inComparisonLength)
{
  	char line[3][MAXOUT];
  	char cline[2][MAXOUT+10];
  	char *name01;
  	long theLineNum;
  	long i;
  	long theLineEnd;
  	long loff;
  	long il1;
  	long il2;
  	long del0;
  	long del1;
  	long ic;
  	long ll0;
  	long ll1;
  	long ll01;
  	long cl0;
  	long cl1;
  	long rl0;
  	long rl1;
  	long i00;
  	long i0n;
  	long i10;
  	long i1n;
  	long ioff0;
  	long ioff1;
  	long qqoff;
  	long lloff;
  	long have_res;
  	long tmp;


	if (markx==2) name01 = name1; 
	else name01 = "\0";

  	i00 = smark[0];
  	i0n = smark[1];
  	i10 = smark[2];
  	i1n = smark[3];
  
  	ioff0=smin0-smins;
  	ioff1=smin1-smins;
  
  	if (markx==4) return;

  	if (markx==3) {
    	fprintf(outfd,">%s ..\n",name0);
    	for (i=0; i<inComparisonLength; i++) {
   			/* if (inQuerySeq[i]=='-') fputc('.',outfd);
      		else */
      		fputc(inQuerySeq[i],outfd);
      		if (i%50 == 49) fputc('\n',outfd);
    	}
    	fputc('\n',outfd);
    	fprintf(outfd,">%s ..\n",name1);
    	for (i=0; i<inComparisonLength; i++) {
    		/* if (inLibSeq[i]=='-') fputc('.',outfd);
      		else */
      		fputc(inLibSeq[i],outfd);
      		if (i%50 == 49) fputc('\n',outfd);
    	}
    	fputc('\n',outfd);
    	return;
  	}

  	if (markx==10) {
    	fprintf(outfd,">%s ..\n",name0);
    	fprintf(outfd,"; sq_type: %c\n",sqtype[0]);
    	fprintf(outfd,"; al_start: %d\n",min0+1);
    	fprintf(outfd,"; al_stop: %d\n",max0);
    	fprintf(outfd,"; al_display_start: %d\n",ioff0+1);

    	have_res = 0;
    	for (i=0; i<inComparisonLength; i++) {
      		if (!have_res && inQuerySeq[i]==' ') fputc('-',outfd);
      		else if (inQuerySeq[i]==' ') break;
      		else {
				have_res = 1;
				fputc(inQuerySeq[i],outfd);
      		}
      		if (i%50 == 49) fputc('\n',outfd);
    	}
    	if ((i-1)%50!=49 || inQuerySeq[i-1]==' ') fputc('\n',outfd);
    	fprintf(outfd,">%s ..\n",name1);
    	fprintf(outfd,"; sq_len: %d\n",n1);
    	fprintf(outfd,"; sq_type: %c\n",sqtype[0]);
    	fprintf(outfd,"; al_start: %ld\n",loffset+min1+1);
    	fprintf(outfd,"; al_stop: %ld\n",loffset+max1);
    	fprintf(outfd,"; al_display_start: %d\n",loffset+ioff1+1);

    	have_res = 0;
    	for (i=0; i<inComparisonLength; i++) {
      		if (!have_res && inLibSeq[i]==' ') fputc('-',outfd);
      		else if (inLibSeq[i]==' ') break;
      		else {
				have_res = 1;
				fputc(inLibSeq[i],outfd);
      		}
      		if (i%50 == 49) fputc('\n',outfd);
    	}
    	if ((i-1)%50!=49 || inLibSeq[i-1]==' ') fputc('\n',outfd);
    	return;
  	}

	/* Blank out the lines used for showing the sequence alignment */
  	for (i=0; i<3; i++) memset(line[i],' ',MAXOUT);

  	ic = 0; del0=del1=0;
  	for (theLineNum=0; theLineNum < (inComparisonLength+llen-1)/llen; theLineNum++) {
    	loff = theLineNum * llen;
    	theLineEnd = min(llen, inComparisonLength - loff);

    	ll0 = NO; 
    	ll1 = NO;

		/* Blank out the lines used for seq. numbers */
    	for (i = 0; i < 2; i++) memset(cline[i],' ',MAXOUT);

    	for (i = 0; i < theLineEnd; i++, ic++,ioff0++,ioff1++) {
      		cl0 =  cl1 = rl0 = rl1 = YES;
      		if ((line[0][i]=inQuerySeq[ic])=='-') {
				del0++; cl0=rl0=NO;
      		}
      		if ((line[2][i]=inLibSeq[ic])=='-') {
				del1++; cl1=rl1=NO;
      		}

      		if (inQuerySeq[ic]==' ') {
      			del0++; 
      			cl0 = rl0 = NO;
      		}
      		else ll0 = YES;
      		
      		if (inLibSeq[ic]==' ') {
      			del1++; 
      			cl1 = rl1 = NO;
      		}
      		else ll1 = YES;
			
			/* Fill in the sequence residue numbers */
      		qqoff = sq0off - 1 + (long)(ioff0-del0);
      		if (cl0 && qqoff%10 == 9)  {
				sprintf(&cline[0][i],"%8ld",qqoff+1l);
				cline[0][i+8]=' ';
				rl0 = NO;
      		}
      		else if (cl0 && qqoff== -1) {
				sprintf(&cline[0][i],"%8ld",0l);
				cline[0][i+8]=' ';
				rl0 = NO;
      		}
      		else if (rl0 && (qqoff+1)%10 == 0) {
				sprintf(&cline[0][i],"%8ld",qqoff+1);
				cline[0][i+8]=' ';
      		}
      
      		lloff = sq1off-1 + loffset + (long)(ioff1-del1);
#ifndef TFASTX      		
      		if (cl1 && lloff%10 == 9)  {
      			sprintf(&cline[1][i],"%8ld",lloff+1l);
#else
			if (cl1 && (lloff)%10 == 0)  {
				sprintf(&cline[1][i],"%8ld",lloff);	
#endif      	     			
				cline[1][i+8]=' ';
				rl1 = NO;
      		}
      		else if (cl1 && lloff== -1) {
				sprintf(&cline[1][i],"%8ld",0l);
				cline[1][i+8]=' ';
				rl1 = NO;
      		}
#ifndef TFASTX 
      		else if (rl1 && (lloff+1)%10 == 0) {
				sprintf(&cline[1][i],"%8ld",lloff+1);
#else
			else if (rl1 && (lloff)%10 == 0) {
				sprintf(&cline[1][i],"%8ld",lloff);
#endif     				
				cline[1][i+8]=' ';
      		}
      
			/* Put the character in line[1] which represents the similarity of the two seqs.*/
      		line[1][i] = ' ';
      		if (ioff0-del0 >= min0 && ioff0-del0 <= max0 && line[2][i] != ' ') {
				if (toupper(line[0][i])==toupper(line[2][i]) || (dnaseq && (
	    			(toupper(line[0][i])=='T' && toupper(line[2][i])=='U') ||
	    			(toupper(line[0][i])=='U' && toupper(line[2][i])=='T'))))
	  				switch (markx) {
	  
	  					case 0: line[1][i]= ':';
	    					break;
	  					case 1: line[1][i]= ' ';
	    					break;
	  					case 2: line[1][i]= '.';
	    					break;
	  				}
				else if (markx==2) line[1][i]=line[2][i];
				else if ((il1=iidex(sq,line[0][i]))>=0 && (il2=iidex(sq,line[2][i]))>=0 &&
		 				 pam2[il1][il2]>= 0)
	    			line[1][i]= (markx) ? 'x':'.';
				else if ((il1=iidex(sq,line[0][i]))>=0 && (il2=iidex(sq,line[2][i]))>=0)
	    			line[1][i]= (markx) ? 'X':' ';
      		}
      		else if (markx==2) line[1][i]=line[2][i];

      		if (markx==0) {
				if (ioff0-del0 == i00 && ioff1-del1 == i10) {
	  				line[1][i]='X';
	  				i00 = i10 = -1;
				}
				if (ioff0-del0 == i0n && ioff1-del1 == i1n) {
	  				line[1][i]='X';
	  				i0n = i1n = -1;
				}
				if ((ioff0-del0 == i00) || (ioff0-del0 == i0n)) {
	  				line[1][i]='^';
	  				if(ioff0-del0 == i00) i00= -1;
	  				else i0n = -1;
				}
				if (ioff1-del1 == i10 || ioff1-del1 == i1n) {
	  				line[1][i]='v';
	  				if(ioff1-del1 == i10) i10= -1;
	  				else i1n = -1;
				}
      		}
      		
#ifdef TFASTX      		
      		ioff1+=2;
#endif      			
    	}
    	/* Blank out the unused end portions of the lines */
    	for (i = 0; i < 3; i++) {
    		line[i][theLineEnd]=0;
    	}
    	for (i = 0; i < 2; i++) {
    		cline[i][theLineEnd + 7] = 0;
    	}
    
    	ll01 = ll0&&ll1;
    	if (markx == 2 && (!showall || ll0)) ll1=0;
    	fprintf(outfd,"\n");
    	if (ll0) fprintf(outfd,"%s\n",cline[0]);
    	if (ll0) fprintf(outfd,"%-6s %s\n",name0,line[0]);
    	if (ll01) fprintf(outfd,"%-6s %s\n",name01,line[1]);
    	if (ll1) fprintf(outfd,"%-6s %s\n",name1,line[2]);
    	if (ll1) fprintf(outfd,"%s\n",cline[1]);
  	}
}

/*==========================================================
*/
static float gscale= -1.0;

disgraph(n0, n1,percent,score,min0,min1,max0,max1)
     long n0, n1, min0, min1, max0, max1;
     float percent;
     long score;
{
  long i, gstart, gstop, gend;
  char line[MAXOUT+1];

  memset(line,' ',llen);

  line[llen-1]='\0';
  if (gscale < 0.0) {
    gscale = (float)llen/(float)n0;
    fprintf(outfd,"%-6s %4d-%4d:     %5.1f%%:%s:\n",name0,1,n0,100.0,line);
  }

  gstart = (long)(gscale*(float)min0+0.5);
  gstop = (long)(gscale*(float)max0+0.5);
  gend = gstop+(long)(gscale*(float)(n1-max1));

  if (gstop >= llen) gstop = llen-1;
  if (gend >= llen) gend = llen-1;
  for (i=0; i<gstart; i++) line[i]=' ';
  for (; i<gstop; i++) line[i]='-';
  for (; i<llen; i++) line[i]=' ';

  line[gend]=':';
  line[llen]='\0';

  fprintf(outfd,"%-6s %4d-%4d:%4d %5.1f%%:%s\n",
	  name1,min0+1,max0,score,percent,line);
}

aancpy(to,from,count)
     char *to, *from;
     long count;
{
  char *tp;
  tp=to;
  while (count--&& *from>=0) {
    if (*from<nsq) *tp++ = sq[*(from++)];
    else *tp++ = *from++;
  }
  *tp=0;
}

r_memcpy(dest,src,cnt)
     char *dest, *src;
     long cnt;
{
  while (cnt--) *dest++ = *src++;
}

l_memcpy(dest,src,cnt)
     char *dest, *src;
     long cnt;
{
  dest = dest+cnt;
  src = src+cnt;
  while (cnt--) *--dest = *--src;
}

iidex(str, chr)
	char *str, chr;
{
	long i;
	for (i=0; str[i]; i++) if (str[i]==chr) return i;
	return (-1);
	}

opnline() {}

clsline() {}

/*
#ifndef __MWERKS__
toupper(c)
	char c;
{
	if (c>='a' && c<='z') return (c-'a'+'A');
	return c;
	}
#endif
*/

#ifdef VMS
memset(str, c, cnt)
	char *str; long cnt; char c;
{
	while (cnt--) *str++ = c;
	}
#endif
